#!/usr/bin/env python

divine = "divine"

import os
import sys

def benchmark_functions():
    lengths = [ 16, 64, 1024, 4096 ]
    flavours = [ "ABC", "SEQ", "ALTER" ]

    for flavour in flavours:
        for length in lengths:
            print( "--- FLALOUR {} LENGTH {} ---".format( flavour, length ) )
            os.environ['F'] = flavour
            os.environ['L'] = str(length)
            sys.stdout.flush()
            os.system( "make" )
            benchmark( "parser.bc", length, flavour )

def benchmark( name, length, flavour ):
    params = [ divine, "check", "--lart abstraction:mstring:explicit", "--symbolic", "--sequential" ]
    params.append( "-o ignore:control" )
    params.append( "--max-memory 80G" )
    params.append( "--threads 4" )
    params.append( "--max-time 3600" )
    params.append( "-o ignore:memory" )
    params.append( "--report-filename {}".format( name + "-" + flavour + "-" + str(length) + ".report" ) )
    params.append( name )
    os.system( ' '.join(params) )

if __name__ == "__main__":
    benchmark_functions()
