#include <stdio.h>
#include <string.h>
#include <stdbool.h>

#include <dios.h>
#include <rst/domains.h>

extern bool scan_buffer( char * buff, size_t len );

extern int yylex( void );
extern int yyparse( void );

#ifdef ABC
static inline char * expr( int size ) {
    int mid = size / 2;
    return __mstring_sym_val( 8,
	'1', 1, mid,
	'2', 1, mid,
	'3', 1, mid,
	'+', mid, mid + 1,
	'1', mid + 1, size,
	'2', mid + 1, size,
	'3', mid + 1, size,
	'\0', size + 2, size + 3 );
}
#endif

#ifdef SEQ
static inline char * expr( int size ) {
    int mid = size / 2;
    return __mstring_sym_val( 4,
	'1', 1, mid,
	'+', mid, mid + 1,
	'1', mid + 1, size,
	'\0', size + 2, size + 3 );
}
#endif

#ifdef ALTER
static inline char * expr( int size ) {
    int mid = size / 2;
    return __mstring_sym_val( 10,
	'1', 1, mid,
	'0', 1, mid,
	'1', 1, mid,
	'0', 1, mid,
	'+', mid, mid + 1,
	'1', mid + 1, size,
	'0', mid + 1, size,
	'1', mid + 1, size,
	'0', mid + 1, size,
	'\0', size + 2, size + 3 );
}
#endif

int main() {
    char * e = expr( LENGTH );
    assert( scan_buffer( e, strlen( e ) + 2 ) );
    yylex();
    free( e );
}

